Package org.apache.storm.streams.windowing

# Interface Window<L,I>

Type Parameters:
  `L` - the type of window length parameter (E.g. Count, Duration)
  `I` - the type of the sliding interval parameter (E.g. Count, Duration)

All Superinterfaces:
  `Serializable`

All Known Implementing Classes:
  `BaseWindow`, `SlidingWindows`, `TumblingWindows`

public interface Window<L,I> extends Serializable
The window specification within `Stream`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `BaseWindowedBolt.Duration`
  `getLag()`
  The maximum time lag of the tuple timestamp in milliseconds.
  `String`
  `getLateTupleStream()`
  The name of the stream where late arriving tuples should be emitted.
  `I`
  `getSlidingInterval()`
  The sliding interval of the window.
  `String`
  `getTimestampField()`
  The name of the field in the tuple that contains the timestamp when the event occurred as a long value.
  `L`
  `getWindowLength()`
  The length of the window.

- ## Method Details

  - ### getWindowLength

    L getWindowLength()
    The length of the window.
    Returns:
      the window length

  - ### getSlidingInterval

    I getSlidingInterval()
    The sliding interval of the window.
    Returns:
      the sliding interval

  - ### getTimestampField

    String getTimestampField()
    The name of the field in the tuple that contains the timestamp when the event occurred as a long value. This is used of event-time based processing. If this config is set and the field is not present in the incoming tuple, an `IllegalArgumentException` will be thrown.
    Returns:
      the timestamp field.

  - ### getLateTupleStream

    String getLateTupleStream()
    The name of the stream where late arriving tuples should be emitted. If this is not provided, the late tuples would be discarded.
    Returns:
      the name of the stream used to emit late tuples on

  - ### getLag

    BaseWindowedBolt.Duration getLag()
    The maximum time lag of the tuple timestamp in milliseconds. It means that the tuple timestamps cannot be out of order by more than this amount.
    Returns:
      the lag